﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

//using System.Deployment; (stuff moved since Beta1)
using System.Deployment.Application;

namespace APIDemo
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();

			this.Text = "V 6.0";
		}

		private void btnUpdate_Click(object sender, EventArgs e)
		{
			CheckForUpdate();
		}


		public void CheckForUpdate()
		{
			if (ApplicationDeployment.IsNetworkDeployed)
			{
				ApplicationDeployment currentDeploy =
					ApplicationDeployment.CurrentDeployment;


				MessageBox.Show("Getting update information from " +
					currentDeploy.UpdateLocation);

				if (currentDeploy.CheckForUpdate())
				{
					UpdateCheckInfo ucInfo = currentDeploy.CheckForDetailedUpdate();
					//sizeOfUpdate = ucInfo.UpdateSize;
					if (!ucInfo.IsUpdateRequired)
					{
						DialogResult dr = MessageBox.Show("An update is available.  Would you like to update the application now?",
															"Update Available", MessageBoxButtons.OKCancel);
						if (DialogResult.OK == dr)
						{
							UpdateApplication();
						}
					}
					else
					{
						UpdateApplication();
					}
				}
			}
			else MessageBox.Show("Not Deployed.");
		}

		void UpdateApplication()
		{
			ApplicationDeployment ad =
					ApplicationDeployment.CurrentDeployment;

			if (ad.Update())
			{
				MessageBox.Show("Update Completed");
				DialogResult dr = MessageBox.Show("The application has been	updated. Restart?", "Restart Application",
					MessageBoxButtons.OKCancel);
				if (DialogResult.OK == dr)
				{
					Application.Restart();
				}
				else
				{
					MessageBox.Show("New version available at next restart.");
				}
			}
			else
			{
				MessageBox.Show("Update failed");
			}
		}

	}
}