using System;
using System.Reflection;
using System.Security; 
using System.Security.Permissions; 
using System.Security.Policy; 
using System.Windows.Forms;

[assembly: AssemblyKeyFile("test.snk")]

class MyApp
{
	[STAThread]
	static void Main()
	{
		Application.Run(new MyForm());
	}
}

class MyForm : Form
{
	private TextBox tb = new TextBox();

	public MyForm()
	{
		this.Text = "Max Security Zone is: " + getMaxZone();

		Font = new System.Drawing.Font("Tahoma", 14);
		BackColor = System.Drawing.Color.Orange;

		Button btn = new Button();
		btn.Text = "Exit";
		btn.Click += new EventHandler(onClick);
		this.Controls.Add(btn);
		btn.Top = (int)(ClientRectangle.Height/4 - btn.Height/2);
		btn.Left = (int)(ClientRectangle.Width/2 - btn.Width/2);
		btn.Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right;

		tb.Multiline = true;
		tb.Top = btn.Top + (btn.Height * 2);
		tb.Height = (int)(this.ClientRectangle.Height - tb.Top);
		tb.Width = ClientRectangle.Width;
		tb.Anchor = AnchorStyles.Bottom | AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right;
		tb.ScrollBars = ScrollBars.Both;
		this.Controls.Add(tb);

		fillEvidence();
	}

	private void onClick(object sender, EventArgs e)
	{
		MessageBox.Show("exiting now.");
		Application.Exit();	
	}


    private bool Demand (SecurityZone zone)  
	{ 
		try 
		{ 
			new ZoneIdentityPermission (zone).Demand (); 
			return true;
		} 
		catch (SecurityException) 
		{ 
			return false;
		} 
     } 

     private string getMaxZone() 
     { 
		try
		{
			foreach (object obj in AppDomain.CurrentDomain.Evidence)
			if (obj is Zone) return ((Zone)obj).SecurityZone.ToString();
		}
		catch (SecurityException)
		{
			return "No ZoneIdentity Permission ;)";
		}

		return "None Found in Evidence.";
     } 

     private void fillEvidence()	
     {
		 try
		 {
			 foreach (object obj in AppDomain.CurrentDomain.Evidence)
			 {
				 tb.Text += string.Concat(obj, Environment.NewLine);
			 }
		 }
		 catch (SecurityException ex)
		 {
			 tb.Text = ex.ToString();
		 }
     }
}